pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT > Class Template Reference
Module features

OURCVFHEstimation estimates the Oriented, Unique and Repetable Clustered Viewpoint Feature Histogram (CVFH) descriptor for a given point cloud dataset given XYZ data and normals, as presented in: More...

`#include <pcl/features/our_cvfh.h>`

Inheritance diagram for pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >:

## Public Types

typedef boost::shared_ptr< OURCVFHEstimation< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const OURCVFHEstimation< PointInT, PointNT, PointOutT > > | ConstPtr
typedef Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef pcl::search::Search< PointNormal >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT >::Ptr | PointInTPtr
Public Types inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
typedef pcl::PointCloud< PointNT > | PointCloudN
typedef PointCloudN::Ptr | PointCloudNPtr
typedef PointCloudN::ConstPtr | PointCloudNConstPtr
typedef boost::shared_ptr< FeatureFromNormals< PointInT, PointNT, PointOutT > > | Ptr
typedef boost::shared_ptr< const FeatureFromNormals< PointInT, PointNT, PointOutT > > | ConstPtr
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| OURCVFHEstimation ()
| Empty constructor. More...
Eigen::Matrix4f | createTransFromAxes (Eigen::Vector3f &evx, Eigen::Vector3f &evy, Eigen::Vector3f &evz, Eigen::Affine3f &transformPC, Eigen::Matrix4f &center_mat)
| Creates an affine transformation from the RF axes. More...
void | computeRFAndShapeDistribution (PointInTPtr &processed, PointCloudOut &output, std::vector< pcl::PointIndices > &cluster_indices)
| Computes SGURF and the shape distribution based on the selected SGURF. More...
bool | sgurf (Eigen::Vector3f &centroid, Eigen::Vector3f &normal_centroid, PointInTPtr &processed, std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &transformations, PointInTPtr &grid, pcl::PointIndices &indices)
| Computes SGURF. More...
void | filterNormalsWithHighCurvature (const pcl::PointCloud< PointNT > &cloud, std::vector< int > &indices_to_use, std::vector< int > &indices_out, std::vector< int > &indices_in, float threshold)
| Removes normals with high curvature caused by real edges or noisy data. More...
void | setViewPoint (float vpx, float vpy, float vpz)
| Set the viewpoint. More...
void | setRadiusNormals (float radius_normals)
| Set the radius used to compute normals. More...
void | getViewPoint (float &vpx, float &vpy, float &vpz)
| Get the viewpoint. More...
void | getCentroidClusters (std::vector< Eigen::Vector3f > &centroids)
| Get the centroids used to compute different CVFH descriptors. More...
void | getCentroidNormalClusters (std::vector< Eigen::Vector3f > &centroids)
| Get the normal centroids used to compute different CVFH descriptors. More...
void | setClusterTolerance (float d)
| Sets max. More...
void | setEPSAngleThreshold (float d)
| Sets max. More...
void | setCurvatureThreshold (float d)
| Sets curvature threshold for removing normals. More...
void | setMinPoints (size_t min)
| Set minimum amount of points for a cluster to be considered. More...
void | setNormalizeBins (bool normalize)
| Sets wether if the signatures should be normalized or not. More...
void | getClusterIndices (std::vector< pcl::PointIndices > &indices)
| Gets the indices of the original point cloud used to compute the signatures. More...
void | getClusterAxes (std::vector< short > &cluster_axes)
| Gets the number of non-disambiguable axes that correspond to each centroid. More...
void | setRefineClusters (float rc)
| Sets the refinement factor for the clusters. More...
void | getTransforms (std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > &trans)
| Returns the transformations aligning the point cloud to the corresponding SGURF. More...
void | getValidTransformsVec (std::vector< bool > &valid)
| Returns a boolean vector indicating of the transformation obtained by getTransforms() represents a valid SGURF. More...
void | setAxisRatio (float f)
| Sets the min axis ratio between the SGURF axes to decide if disambiguition is feasible. More...
void | setMinAxisValue (float f)
| Sets the min disambiguition axis value to generate several SGURFs for the cluster when disambiguition is difficult. More...
void | compute (PointCloudOut &output)
| Overloaded computed method from pcl::Feature. More...
Public Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
| FeatureFromNormals ()
| Empty constructor. More...
virtual | ~FeatureFromNormals ()
| Empty destructor. More...
void | setInputNormals (const PointCloudNConstPtr &normals)
| Provide a pointer to the input dataset that contains the point normals of the XYZ dataset. More...
PointCloudNConstPtr | getInputNormals () const
| Get a pointer to the normals of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Attributes

std::vector< Eigen::Vector3f > | centroids_dominant_orientations_
| Centroids that were used to compute different OUR-CVFH descriptors. More...
std::vector< Eigen::Vector3f > | dominant_normals_
| Normal centroids that were used to compute different OUR-CVFH descriptors. More...
std::vector< pcl::PointIndices > | clusters_
| Indices to the points representing the stable clusters. More...
std::vector< short > | cluster_axes_
| Mapping from clusters to OUR-CVFH descriptors. More...
Protected Attributes inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
PointCloudNConstPtr | normals_
| A pointer to the input dataset that contains the point normals of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Detailed Description

### template<typename PointInT, typename PointNT, typename PointOutT = pcl::VFHSignature308>
class pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >

OURCVFHEstimation estimates the Oriented, Unique and Repetable Clustered Viewpoint Feature Histogram (CVFH) descriptor for a given point cloud dataset given XYZ data and normals, as presented in:

- OUR-CVFH – Oriented, Unique and Repeatable Clustered Viewpoint Feature Histogram for Object Recognition and 6DOF Pose Estimation A. Aldoma, F. Tombari, R.B. Rusu and M. Vincze DAGM-OAGM 2012 Graz, Austria The suggested PointOutT is pcl::VFHSignature308.

Author
  Aitor Aldoma

Definition at line 62 of file our_cvfh.h.

## Member Typedef Documentation

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

typedef boost::shared_ptr<const OURCVFHEstimation<PointInT, PointNT, PointOutT> > pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::ConstPtr

Definition at line 66 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

typedef pcl::search::Search<PointNormal>::Ptr pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::KdTreePtr

Definition at line 76 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

typedef Feature<PointInT, PointOutT>::PointCloudOut pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::PointCloudOut

Definition at line 75 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

typedef pcl::PointCloud<PointInT>::Ptr pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::PointInTPtr

Definition at line 77 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

typedef boost::shared_ptr<OURCVFHEstimation<PointInT, PointNT, PointOutT> > pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::Ptr

Definition at line 65 of file our_cvfh.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::OURCVFHEstimation | ( |  | ) |

inline

Empty constructor.

Definition at line 79 of file our_cvfh.h.

References pcl::Feature< PointInT, PointOutT >::feature_name_, pcl::Feature< PointInT, PointOutT >::k_, and pcl::Feature< PointInT, PointOutT >::search_radius_.

## Member Function Documentation

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute | ( | PointCloudOut & | output | ) |

Overloaded computed method from pcl::Feature.

Parameters

  [out] | output | the resultant point cloud model dataset containing the estimated features

Definition at line 52 of file our_cvfh.hpp.

References pcl::search::Search< PointT >::getInputCloud(), pcl::PointIndices::header, pcl::PointCloud< PointT >::header, pcl::PointCloud< PointT >::height, pcl::PointIndices::indices, pcl::PointCloud< PointT >::points, pcl::search::Search< PointT >::radiusSearch(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setMinAxisValue().

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution | ( | PointInTPtr & | processed,
|  | PointCloudOut & | output,
|  | std::vector< pcl::PointIndices > & | cluster_indices
| ) |  |

Computes SGURF and the shape distribution based on the selected SGURF.

Parameters

  [in] | processed | the input cloud
  [out] | output | the resulting signature
  [in] | cluster_indices | the indices of the stable cluster

Definition at line 375 of file our_cvfh.hpp.

References pcl::PointCloud< PointT >::clear(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::compute(), pcl::Feature< PointInT, PointOutT >::compute(), pcl::compute3DCentroid(), pcl::copyPointCloud(), pcl::getMaxDistance(), pcl::PointCloud< PointT >::height, pcl::PointCloud< PointT >::points, pcl::VFHEstimation< PointInT, PointNT, PointOutT >::setCentroidToUse(), pcl::PCLBase< PointInT >::setIndices(), pcl::PCLBase< PointInT >::setInputCloud(), pcl::NormalEstimation< PointInT, PointOutT >::setInputCloud(), pcl::FeatureFromNormals< PointInT, PointNT, PointOutT >::setInputNormals(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::setNormalizeBins(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::setNormalToUse(), pcl::Feature< PointInT, PointOutT >::setRadiusSearch(), pcl::Feature< PointInT, PointOutT >::setSearchMethod(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::setUseGivenCentroid(), pcl::VFHEstimation< PointInT, PointNT, PointOutT >::setUseGivenNormal(), pcl::transformPointCloud(), and pcl::PointCloud< PointT >::width.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::createTransFromAxes().

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

Eigen::Matrix4f pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::createTransFromAxes | ( | Eigen::Vector3f & | evx,
|  | Eigen::Vector3f & | evy,
|  | Eigen::Vector3f & | evz,
|  | Eigen::Affine3f & | transformPC,
|  | Eigen::Matrix4f & | center_mat
| ) |  |

inline

Creates an affine transformation from the RF axes.

Parameters

  [in] | evx | the x-axis
  [in] | evy | the y-axis
  [in] | evz | the z-axis
  [out] | transformPC | the resulting transformation
  [in] | center_mat | 4x4 matrix concatenated to the resulting transformation

Definition at line 101 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::computeRFAndShapeDistribution(), pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature(), and pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::sgurf().

template<typename PointInT , typename PointNT , typename PointOutT >

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::filterNormalsWithHighCurvature | ( | const pcl::PointCloud< PointNT > & | cloud,
|  | std::vector< int > & | indices_to_use,
|  | std::vector< int > & | indices_out,
|  | std::vector< int > & | indices_in,
|  | float | threshold
| ) |  |

Removes normals with high curvature caused by real edges or noisy data.

Parameters

  [in] | cloud | pointcloud to be filtered
  [in] | indices_to_use |
  [out] | indices_out | the indices of the points with higher curvature than threshold
  [out] | indices_in | the indices of the remaining points after filtering
  [in] | threshold | threshold value for curvature

Definition at line 161 of file our_cvfh.hpp.

References pcl::PointCloud< PointT >::points.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::createTransFromAxes().

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidClusters | ( | std::vector< Eigen::Vector3f > & | centroids | ) |

inline

Get the centroids used to compute different CVFH descriptors.

Parameters

  [out] | centroids | vector to hold the centroids

Definition at line 195 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::centroids_dominant_orientations_.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidNormalClusters | ( | std::vector< Eigen::Vector3f > & | centroids | ) |

inline

Get the normal centroids used to compute different CVFH descriptors.

Parameters

  [out] | centroids | vector to hold the normal centroids

Definition at line 205 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::dominant_normals_.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterAxes | ( | std::vector< short > & | cluster_axes | ) |

inline

Gets the number of non-disambiguable axes that correspond to each centroid.

Parameters

  [out] | cluster_axes | vector mapping each centroid to the number of signatures

Definition at line 270 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::cluster_axes_.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterIndices | ( | std::vector< pcl::PointIndices > & | indices | ) |

inline

Gets the indices of the original point cloud used to compute the signatures.

Parameters

  [out] | indices | vector of point indices

Definition at line 261 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::clusters_.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getTransforms | ( | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | trans | ) |

inline

Returns the transformations aligning the point cloud to the corresponding SGURF.

Parameters

  [out] | trans | vector of transformations

Definition at line 288 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getValidTransformsVec | ( | std::vector< bool > & | valid | ) |

inline

Returns a boolean vector indicating of the transformation obtained by getTransforms() represents a valid SGURF.

Parameters

  [out] | valid | vector of booleans

Definition at line 298 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getViewPoint | ( | float & | vpx,
|  | float & | vpy,
|  | float & | vpz
| ) |  |

inline

Get the viewpoint.

Parameters

  [out] | vpx | the X coordinate of the viewpoint
  [out] | vpy | the Y coordinate of the viewpoint
  [out] | vpz | the Z coordinate of the viewpoint

Definition at line 184 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setAxisRatio | ( | float | f | ) |

inline

Sets the min axis ratio between the SGURF axes to decide if disambiguition is feasible.

Parameters

  [in] | f | the ratio between axes

Definition at line 307 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setClusterTolerance | ( | float | d | ) |

inline

Sets max.

Euclidean distance between points to be added to the cluster

Parameters

  [in] | d | the maximum Euclidean distance

Definition at line 216 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setCurvatureThreshold | ( | float | d | ) |

inline

Sets curvature threshold for removing normals.

Parameters

  [in] | d | the curvature threshold

Definition at line 234 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setEPSAngleThreshold | ( | float | d | ) |

inline

Sets max.

deviation of the normals between two points so they can be clustered together

Parameters

  [in] | d | the maximum deviation

Definition at line 225 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setMinAxisValue | ( | float | f | ) |

inline

Sets the min disambiguition axis value to generate several SGURFs for the cluster when disambiguition is difficult.

Parameters

  [in] | f | the min axis value

Definition at line 316 of file our_cvfh.h.

References pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::compute().

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setMinPoints | ( | size_t | min | ) |

inline

Set minimum amount of points for a cluster to be considered.

Parameters

  [in] | min | the minimum amount of points to be set

Definition at line 243 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setNormalizeBins | ( | bool | normalize | ) |

inline

Sets wether if the signatures should be normalized or not.

Parameters

  [in] | normalize | true if normalization is required, false otherwise

Definition at line 252 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setRadiusNormals | ( | float | radius_normals | ) |

inline

Set the radius used to compute normals.

Parameters

  [in] | radius_normals | the radius

Definition at line 173 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setRefineClusters | ( | float | rc | ) |

inline

Sets the refinement factor for the clusters.

Parameters

  [in] | rc | the factor used to decide if a point is used to estimate a stable cluster

Definition at line 279 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

void pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::setViewPoint | ( | float | vpx,
|  | float | vpy,
|  | float | vpz
| ) |  |

inline

Set the viewpoint.

Parameters

  [in] | vpx | the X coordinate of the viewpoint
  [in] | vpy | the Y coordinate of the viewpoint
  [in] | vpz | the Z coordinate of the viewpoint

Definition at line 162 of file our_cvfh.h.

template<typename PointInT , typename PointNT , typename PointOutT >

bool pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::sgurf | ( | Eigen::Vector3f & | centroid,
|  | Eigen::Vector3f & | normal_centroid,
|  | PointInTPtr & | processed,
|  | std::vector< Eigen::Matrix4f, Eigen::aligned_allocator< Eigen::Matrix4f > > & | transformations,
|  | PointInTPtr & | grid,
|  | pcl::PointIndices & | indices
| ) |  |

Computes SGURF.

Parameters

  [in] | centroid | the centroid of the cluster
  [in] | normal_centroid | the average of the normals
  [in] | processed | the input cloud
  [out] | transformations | the transformations aligning the cloud to the SGURF axes
  [out] | grid | the cloud transformed internally
  [in] | indices | the indices of the stable cluster

Definition at line 191 of file our_cvfh.hpp.

References pcl::demeanPointCloud(), pcl::getMaxDistance(), pcl::PointIndices::indices, and pcl::transformPointCloud().

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::createTransFromAxes().

## Member Data Documentation

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<Eigen::Vector3f> pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::centroids_dominant_orientations_

protected

Centroids that were used to compute different OUR-CVFH descriptors.

Definition at line 398 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidClusters().

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<short> pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::cluster_axes_

protected

Mapping from clusters to OUR-CVFH descriptors.

Definition at line 404 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterAxes().

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<pcl::PointIndices> pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::clusters_

protected

Indices to the points representing the stable clusters.

Definition at line 402 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getClusterIndices().

template<typename PointInT , typename PointNT , typename PointOutT = pcl::VFHSignature308>

std::vector<Eigen::Vector3f> pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::dominant_normals_

protected

Normal centroids that were used to compute different OUR-CVFH descriptors.

Definition at line 400 of file our_cvfh.h.

Referenced by pcl::OURCVFHEstimation< PointInT, PointNT, PointOutT >::getCentroidNormalClusters().

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/our_cvfh.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/our_cvfh.hpp